/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PPAT                                                     */
/* Tabela : PRODPRINATIV                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 22/01/2004 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PPAT
BEFORE INSERT OR UPDATE OR DELETE
ON PRODPRINATIV FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPPAT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPRODUTO,0) <> NVL(:NEW.CDPRODUTO,0)) OR
         (NVL(:OLD.CDPRINATIV,0)  <> NVL(:NEW.CDPRINATIV,0)) THEN
         :NEW.DTULTATUPPAT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODPRINATIV', '', 'CDPRODUTO='||:OLD.CDPRODUTO||';CDPRINATIV='||:OLD.CDPRINATIV||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODPRINATIV MODIFY DTULTATUPPAT DEFAULT SYSDATE
/
