/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TPRATECOMSOL                                             */
/* Tabela : TPRATECOMSOL                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2007 - Rejane P. Leite                                               */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE TRIGGER DTULTATU_TPRATECOMSOL
BEFORE INSERT OR UPDATE OR DELETE
ON TPRATECOMSOL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTRSO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTPRATCOMSL,0 )   <> NVL(:NEW.CDTPRATCOMSL,0))   OR
         (NVL(:OLD.DSTPRATCOMSL,0 )   <> NVL(:NEW.DSTPRATCOMSL,0)) THEN
         :NEW.DTULTATUTRSO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TPRATECOMSOL', '','CDTPRATCOMSL='||:OLD.CDTPRATCOMSL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TPRATECOMSOL MODIFY DTULTATUTRSO DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TPRATECOMSOL','5.03.010'); END;
/

