/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PLAN                                                     */
/* Tabela : PARAMPLANEJA                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PLAN'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PLAN
GO

CREATE TRIGGER DTULTATU_PLAN
ON PARAMPLANEJA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PARAMPLANEJA', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';' +
                                                 'CDPARPLANEJA='+ CDPARPLANEJA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PARAMPLANEJA
      SET DTULTATUPLAN = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PARAMPLANEJA.IDREQUSERV,  '') = ISNULL(INSERTED.IDREQUSERV,  '')) AND
            (ISNULL(PARAMPLANEJA.IDREQUANAL,  '') = ISNULL(INSERTED.IDREQUANAL,  '')) AND
            (ISNULL(PARAMPLANEJA.IDREQUSETO,  '') = ISNULL(INSERTED.IDREQUSETO,  '')) AND
            (ISNULL(PARAMPLANEJA.IDREQUEXTR,  '') = ISNULL(INSERTED.IDREQUEXTR,  '')) AND
            (ISNULL(PARAMPLANEJA.IDREQUGERAL, '') = ISNULL(INSERTED.IDREQUGERAL, '')) AND
            (ISNULL(PARAMPLANEJA.IDPERCCOME,  '') = ISNULL(INSERTED.IDPERCCOME,  '')) AND
            (ISNULL(PARAMPLANEJA.IDUTILFATCOR,'') = ISNULL(INSERTED.IDUTILFATCOR,'')) AND
            (ISNULL(PARAMPLANEJA.IDUTILFATCOC,'') = ISNULL(INSERTED.IDUTILFATCOC,'')) AND
            (ISNULL(PARAMPLANEJA.IDTIPCALCFAT,'') = ISNULL(INSERTED.IDTIPCALCFAT,'')) AND
            (ISNULL(PARAMPLANEJA.NRCORSAFRA,    0) = ISNULL(INSERTED.NRCORSAFRA,    0)) AND
            (ISNULL(PARAMPLANEJA.NRCORINICSAF,  0) = ISNULL(INSERTED.NRCORINICSAF,  0)) AND
            (ISNULL(PARAMPLANEJA.NRCORENTRSAF,  0) = ISNULL(INSERTED.NRCORENTRSAF,  0)) AND
            (ISNULL(PARAMPLANEJA.IDCARDIAUTIL,'') = ISNULL(INSERTED.IDCARDIAUTIL,'')) AND
            (ISNULL(PARAMPLANEJA.CDNUTRRELAT1,'') = ISNULL(INSERTED.CDNUTRRELAT1,'')) AND
            (ISNULL(PARAMPLANEJA.CDNUTRRELAT2,'') = ISNULL(INSERTED.CDNUTRRELAT2,''));
   END;
END;
GO

