/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MODDOCFISC                                               */
/* Tabela : MODDOCFISC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MODDOCFISC'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MODDOCFISC
GO

CREATE TRIGGER DTULTATU_MODDOCFISC
ON MODDOCFISC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MODDOCFISC', null, 'CDMODDOCFISC=' + CDMODDOCFISC + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MODDOCFISC
      SET DTULTATUMDFI = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(MODDOCFISC.CDMODDOCFISC,0)  = ISNULL(INSERTED.CDMODDOCFISC,0)) AND
            (ISNULL(MODDOCFISC.DSMODDOCFISC,0)  = ISNULL(INSERTED.DSMODDOCFISC,0));
   END;
END;
GO

