const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const errosAvisosNFPage = require('../../../page-objects/parametrizacao/documentos fiscais/errosAvisosNF.po.js');
const j = require('../../../json/leitorJson.po');

describe('Tela Erros e Avisos da NF', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        errosAvisosNFPage.abrir();
    });

    afterEach(() => {
        z.component.menu.open();
        z.component.menu.clickByLabel('Sair');
        z.component.alert.clickButton('Sim');
    });

    it('Acessar a tela Erros e Avisos da NF', () => {
        expect(z.component.header.getTitle()).toBe('Erros e Avisos da NF');
    });

    it('Editar Erros e Avisos da NF - Consiste', () => {
        geralPage.clickGrid('CDERROAVISO', j.getValor('cderroaviso01'), '135707594837063085921541', false);
        geralPage.clickEditar();
        errosAvisosNFPage.editarerroAvisoNF(j.getValor('iderroaviso01'));
        geralPage.clickSalvar();
        expect(geralPage.getTextoPorId('IDERROAVISO')).toBe(j.getValor('iderroaviso01'));
    });

    it('Editar Erros e Avisos da NF - Bloqueia Fechamento', () => {
        geralPage.clickGrid('CDERROAVISO', j.getValor('cderroaviso02'), '135707594837063085921541', false);
        geralPage.clickEditar();
        errosAvisosNFPage.editarerroAvisoNF(j.getValor('iderroaviso02'));
        geralPage.clickSalvar();
        expect(geralPage.getTextoPorId('IDERROAVISO')).toBe(j.getValor('iderroaviso02'));
    });

    it('Editar Erros e Avisos da NF - Não Consiste', () => {
        geralPage.clickGrid('CDERROAVISO', j.getValor('cderroaviso03'), '135707594837063085921541', false);
        geralPage.clickEditar();
        errosAvisosNFPage.editarerroAvisoNF(j.getValor('iderroaviso03'));
        geralPage.clickSalvar();
        expect(geralPage.getTextoPorId('IDERROAVISO')).toBe(j.getValor('iderroaviso03'));
    });

    it('Adicionar Erros e Avisos da NF por Unidade', () => {
        geralPage.trocarAba('Erros e Avisos da NF por Unidade');
        errosAvisosNFPage.adicionarerroAvisoNFUnidade(j.getValor('unidade'), j.getValor('cderroavisofil01'), j.getValor('iderroavisofil01'));
        expect(geralPage.getTextoPorId('DSERROAVISO')).toBe(j.getValor('cderroavisofil01'));
    });

    it('Adicionar Erros e Avisos da NF por Unidade', () => {
        geralPage.trocarAba('Erros e Avisos da NF por Unidade');
        errosAvisosNFPage.adicionarerroAvisoNFUnidade(j.getValor('unidade'), j.getValor('cderroavisofil02'), j.getValor('iderroavisofil02'));
        expect(geralPage.getTextoPorId('DSERROAVISO')).toBe(j.getValor('cderroavisofil02'));
    });

    it('Adicionar Erros e Avisos da NF por Unidade', () => {
        geralPage.trocarAba('Erros e Avisos da NF por Unidade');
        errosAvisosNFPage.adicionarerroAvisoNFUnidade(j.getValor('unidade'), j.getValor('cderroavisofil03'), j.getValor('iderroavisofil03'));
        expect(geralPage.getTextoPorId('DSERROAVISO')).toBe(j.getValor('cderroavisofil03'));
    });

    it('Excluir Erros e Avisos da NF por Unidade', () => {
        geralPage.trocarAba('Erros e Avisos da NF por Unidade');
        errosAvisosNFPage.excluirerroAvisoNFUnidade(j.getValor('unidade'));
        geralPage.clickGrid('CDERROAVISOFIL', j.getValor('cderroavisofil02'), '135707594814248929511555', false);
        geralPage.clickExcluir();
        geralPage.clickSim();
        expect(geralPage.gridHasText('135707594814248929511555', j.getValor('cderroavisofil02'), 1, false)).toBeUndefined();
    });

    it('Editar Erro e Aviso por Unidade', () => {
        geralPage.trocarAba('Erros e Avisos da NF por Unidade');
        errosAvisosNFPage.editarerroAvisoUnidade(j.getValor('unidade'), j.getValor('iderroavisofil'));
        geralPage.clickGrid('CDERROAVISOFIL', j.getValor('cderroavisofil01'), '135707594814248929511555', false);
        geralPage.clickEditar();
        geralPage.selectNative('IDERROAVISOFIL', j.getValor('iderroavisofil02'));
        geralPage.clickSalvar();
        expect(geralPage.getTextoPorId('IDERROAVISOFIL')).toBe(j.getValor('iderroavisofil02'));
    });

    it('Cadastramento automatico por Unidade', () => {
        geralPage.trocarAba('Erros e Avisos da NF por Unidade');
        z.component.footer.clickRightActionByLabel('Cadastramento Automático', false);
        errosAvisosNFPage.cadautomaticoErroAvisoUnidade(j.getValor('unidade'), j.getValor('selecao'), j.getValor('sobrescrevern'), j.getValor('nmfilialdestino01'), j.getValor('nmfilialdestino02'));
        z.component.footer.clickRightActionByLabel('Confirmar', false);
        geralPage.clickOk();
        errosAvisosNFPage.editarerroAvisoUnidade(j.getValor('unidade01'));
        geralPage.filterIt(j.getValor('cderroavisofil01'));
        expect(geralPage.gridHasText('135707594814248929511555', j.getValor('cderroavisofil01'), 1)).toBe(j.getValor('cderroavisofil01'));
    });

    it('Cadastramento automatico por Unidade', () => {
        geralPage.trocarAba('Erros e Avisos da NF por Unidade');
        z.component.footer.clickRightActionByLabel('Cadastramento Automático', false);
        errosAvisosNFPage.cadautomaticoErroAvisoUnidade(j.getValor('unidade'), j.getValor('selecao'), j.getValor('sobrescrevers'), j.getValor('nmfilialdestino01'), j.getValor('nmfilialdestino02'));
        z.component.footer.clickRightActionByLabel('Confirmar', false);
        geralPage.clickOk();
        errosAvisosNFPage.editarerroAvisoUnidade(j.getValor('unidade02'));
        geralPage.filterIt(j.getValor('cderroavisofil01'));
        expect(geralPage.gridHasText('135707594814248929511555', j.getValor('cderroavisofil01'), 1)).toBe(j.getValor('cderroavisofil01'));
    });
});
